<script setup lang="ts">
import { ref } from "vue";
import Status from "../types/status";
import Category from "../types/category";
import Type from "../types/type";

// Appel API
const { baseURL }: { baseURL: string } = useRuntimeConfig().app;
const authorizationHeader = useAuthorizationHeader("application/json");

const { data: statusData } = await useFetch<Status[]>(baseURL + "api/status", {
  headers: authorizationHeader,
});

const { data: categories } = await useFetch<Category[]>(
  baseURL + "api/categories",
  {
    headers: authorizationHeader,
  }
);

const { data: types } = await useFetch<Type[]>(baseURL + "api/types", {
  headers: authorizationHeader,
});

// Déclaration des tableaux pour les filtres sélectionnés
const selectedStatus = ref<Status[]>([]);
const selectedCategories = ref<Category[]>([]);
const selectedTypes = ref<Type[]>([]);

const filter = ref<{
  status: Status[];
  categories: Category[];
  types: Type[];
}>({ status: [], categories: [], types: [] });

// Fonction pour gérer les clics sur les boutons de statut, catégories et types
function togglePressed(
  item: Status | Category | Type,
  type: "status" | "category" | "type"
) {
  item.pressed = !item.pressed;

  if (type === "status") {
    if (item.pressed) {
      selectedStatus.value.push(item as Status);
    } else {
      selectedStatus.value = selectedStatus.value.filter(
        (status) => status.id !== item.id
      );
    }
  } else if (type === "category") {
    if (item.pressed) {
      selectedCategories.value = [item as Category];
    } else {
      selectedCategories.value = [];
    }
  } else if (type === "type") {
    if (item.pressed) {
      selectedTypes.value.push(item as Type);
    } else {
      selectedTypes.value = selectedTypes.value.filter(
        (type) => type.id !== item.id
      );
    }
  }

  // Mettre à jour l'objet 'filter' avec les sélections actuelles
  filter.value = {
    status: selectedStatus.value,
    categories: selectedCategories.value,
    types: selectedTypes.value,
  };
}
</script>

<template>
  <h1 class="fr-grid-row fr-grid-row--center">Filtres</h1>
  <section class="fr-px-2w">
    <fieldset class="fr-fieldset">
      <legend class="fr-fieldset__legend fr-text--regular">Statut :</legend>
      <ul class="fr-tags-group">
        <li v-for="statut in statusData">
          <button
            class="fr-tag"
            :aria-pressed="statut.pressed"
            @click="togglePressed(statut, 'status')"
          >
            {{ statut.name }}
          </button>
        </li>
      </ul>
    </fieldset>
  </section>
  <section class="fr-px-2w">
    <div class="fr-form-group">
      <fieldset class="fr-fieldset">
        <legend class="fr-fieldset__legend fr-text--regular" id="radio-legend">
          Categorie :
        </legend>
        <div class="fr-fieldset__element" v-for="category in categories">
          <div class="fr-radio-group">
            <input
              type="radio"
              :id="`radio-hint-${category.id}`"
              name="radio-hint"
              :value="category"
              @click="togglePressed(category, 'category')"
              v-model="selectedCategories"
            />
            <label class="fr-label" :for="`radio-hint-${category.id}`">
              {{ category.name }}
            </label>
          </div>
        </div>
      </fieldset>
    </div>
  </section>
  <section class="fr-px-2w">
    <div class="fr-form-group">
      <fieldset class="fr-fieldset">
        <legend
          class="fr-fieldset__legend fr-text--regular"
          id="checkboxes-legend"
        >
          Type d'intervention :
        </legend>
        <div class="fr-fieldset__content">
          <div class="fr-checkbox-group" v-for="t in types">
            <input
              type="checkbox"
              :id="`checkboxes-${t.id}`"
              name="checkboxes-1"
              :value="t"
              @click="togglePressed(t, 'type')"
              v-model="selectedTypes"
            />
            <label class="fr-label" :for="`checkboxes-${t.id}`">
              {{ t.name }}
            </label>
          </div>
        </div>
      </fieldset>
    </div>
  </section>
  <section>
    <ul class="fr-btns-group fr-px-2w">
      <li>
        <button class="fr-btn fr-btn--secondary">Effacer</button>
      </li>
      <li>
        <button class="fr-btn">Valider</button>
      </li>
    </ul>
  </section>
</template>
